<?php
#BEGIN_LICENSE
#-------------------------------------------------------------------------
# Module: Newsletter Made Simple (c) 2008 by Robert Campbell 
#         (calguy1000@cmsmadesimple.org)
#  An addon module for CMS Made Simple to provide a flexible
#  mailing list solution.
# 
#-------------------------------------------------------------------------
# CMS - CMS Made Simple is (c) 2005 by Ted Kulp (wishy@cmsmadesimple.org)
# This project's homepage is: http://www.cmsmadesimple.org
#
#-------------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# However, as a special exception to the GPL, this software is distributed
# as an addon module to CMS Made Simple.  You may not use this software
# in any Non GPL version of CMS Made simple, or in any version of CMS
# Made simple that does not indicate clearly and obviously in its admin 
# section that the site was built with CMS Made simple.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Or read it online: http://www.gnu.org/licenses/licenses.html#GPL
#
#-------------------------------------------------------------------------
#END_LICENSE
if( !isset($gCms) ) exit;
if (!$this->CheckPermission('Manage NMS Users')) return;

$this->SetCurrentTab('users');

if( isset($params['cancel']) ) {
  $this->RedirectToTab($id);
  return;
}

$error = '';
$editing = (isset($params['userid']) && $params['userid'] != '' );
$userinfo = array('userid'=>'',
		  'uniqueid'=>'',
		  'email'=>'',
		  'username'=>'',
		  'disabled'=>0,
		  'confirmed'=>0,
		  'htmlemail'=>1,
		  'error_count'=>0,
		  'bounce_count'=>0,
		  'dateadded'=>'',
		  'dateconfirmed'=>'');
$memberlists = array();

if( $editing ) {
  // make sure we have enough params
  if( !isset( $params['uniqueid'] ) ) {
    $this->SetError($this->Lang('error_invalidparams'));
    $this->RedirectToTab($id);
    return;
  }

  // find the user
  $query = "SELECT * FROM ".NMS_USERS_TABLE." WHERE uniqueid = ?";
  $userinfo = $db->GetRow($query,array($params['uniqueid']));
  if( !is_array($userinfo) ) {
    $this->SetError($this->Lang('error_usernotfound'));
    $this->RedirectToTab($id);
    return;
  }

  $smarty->assign('formhidden',
		  $this->CreateInputHidden( $id, 'userid', $userinfo['userid'] ).
		  $this->CreateInputHidden( $id, 'uniqueid', $params['uniqueid'] ));

  // and get his lists
  $query = "SELECT listid FROM ".NMS_LISTUSER_TABLE." WHERE userid = ?";
  $memberlists = $db->GetCol($query,array($userinfo['userid']));
}

if( isset($params['submit']) ) {
  $userinfo['email'] = trim($params['email']);
  $userinfo['username'] = trim($params['username']);
  $userinfo['htmlemail'] = (int)$params['htmlemail'];
  $userinfo['disabled'] = (int)$params['disabled'];
  if( $userinfo['confirmed'] = 0 && (int)$params['confirmed'] == 1 ) {
    $userinfo['dateconfirmed'] = $db->DbTimeStamp(time());
  }
  $userinfo['confirmed'] = (int)$params['confirmed'];
  $userinfo['error_count'] = max(0,(int)$params['error_count']);
  $userinfo['bounce_count'] = max(0,(int)$params['bounce_count']);

  // now validate the userinfo
  if( $userinfo['email'] == '' ) {
    $error = $this->Lang('error_invalidemail');
  }
  if( !is_email($userinfo['email']) ) {
    $error = $this->Lang('error_invalidemail');
  }

  if( $editing ) {
    // existing user
    // validate that the email is not already taken (keeps the list clean).
    $query = 'SELECT userid FROM '.NMS_USERS_TABLE.' WHERE email = ? AND userid != ?';
    $tmp = $db->GetOne($query,array($userinfo['email'],$params['userid']));
    if( $tmp ) {
      $error = $this->Lang('error_emailexists');
    }

    // update the record in the db.
    $query = 'UPDATE '.NMS_USERS_TABLE.' SET email = ?, username = ?, disabled = ?,
              confirmed = ?, htmlemail = ?, dateconfirmed = ?, error_count = ?,
              bounce_count = ?
              WHERE userid = ? AND uniqueid = ?';
    $tmp = $db->Execute($query,array($userinfo['email'],$userinfo['username'],
				     $userinfo['disabled'],$userinfo['confirmed'],
				     $userinfo['htmlemail'],$userinfo['dateconfirmed'],
				     $userinfo['error_count'],$userinfo['bounce_count'],
				     $params['userid'],$params['uniqueid']));
    if( !$tmp ) {
      die($db->sql.' -- '.$db->ErrorMsg());
    }
  }
  else {
    // new user
    // validate that the email is not already taken (keeps the list clean).
    $query = 'SELECT userid FROM '.NMS_USERS_TABLE.' WHERE email = ?';
    $tmp = $db->GetOne($query,array($userinfo['email']));
    if( $tmp ) {
      $error = $this->Lang('error_emailexists');
    }

    $userinfo['uniqueid'] = md5(uniqid(rand(),1));

    $query = 'INSERT INTO '.NMS_USERS_TABLE.'
              (uniqueid,email,username,disabled,confirmed,htmlemail,dateadded,dateconfirmed,
               error_count,bounce_count)
              VALUES (?,?,?,?,?,?,?,?,?,?)';
    $tmp = $db->Execute($query,
			array($userinfo['uniqueid'],$userinfo['email'],$userinfo['username'],
			      $userinfo['disabled'],$userinfo['confirmed'],$userinfo['htmlemail'],
			      $userinfo['dateadded'],$userinfo['dateconfirmed'],
			      $userinfo['error_count'],$userinfo['bounce_count']));
    if( !$tmp ) {
      die($db->sql.' -- '.$db->ErrorMsg());
    }
  }

  if( !$error ) {
    $this->SetMessage($this->Lang('operation_successful'));
    $this->RedirectToTab($id);
  }
}

if( $error ) {
  echo $this->ShowErrors($error);
}
$smarty->assign('memberlists',$memberlists);
$smarty->assign('userinfo',$userinfo);

// query all of the active lists
$query = "SELECT * FROM ".NMS_LIST_TABLE."
          WHERE active = 1 AND COALESCE(dynamic,'') != ''
          ORDER BY listid";
$tmp = $db->GetArray($query);
if( !is_array($tmp) || count($tmp) == 0 ) {
  $this->SetError($this->Lang('error_nolists'));
  $this->RedirectToTab($id);
  return;
}
$lists = array();
foreach( $tmp as $one ) {
  $tmp2 = $one['name'];
  if( !$one['public'] ) $tmp2 .= '('.$this->Lang('private').')';
  $lists[$one['listid']] = $tmp2;
}
$smarty->assign('lists',$lists);

$smarty->assign('formstart',$this->CreateFormStart( $id, 'admin_addedit_user', $returnid ) );
$smarty->assign('formend',$this->CreateFormEnd());

echo $this->ProcessTemplate('admin_addedit_user.tpl');

#
# EOF
#
?>
