<?php
#BEGIN_LICENSE
#-------------------------------------------------------------------------
# Module: Newsletter Made Simple (c) 2012 by Robert Campbell 
#         (calguy1000@cmsmadesimple.org)
#  An addon module for CMS Made Simple to provide a flexible
#  mailing list solution.
# 
#-------------------------------------------------------------------------
# CMS - CMS Made Simple is (c) 2005 by Ted Kulp (wishy@cmsmadesimple.org)
# This project's homepage is: http://www.cmsmadesimple.org
#
#-------------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# However, as a special exception to the GPL, this software is distributed
# as an addon module to CMS Made Simple.  You may not use this software
# in any Non GPL version of CMS Made simple, or in any version of CMS
# Made simple that does not indicate clearly and obviously in its admin 
# section that the site was built with CMS Made simple.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Or read it online: http://www.gnu.org/licenses/licenses.html#GPL
#
#-------------------------------------------------------------------------
#END_LICENSE
if( !isset($gCms) ) exit;
if( !$this->CheckPermission('Manage NMS Jobs') ) exit;

$this->SetCurrentTab('jobs');
if( !isset($params['jobid']) ) {
  $this->SetError($this->Lang('error_insufficientparams'));
  $this->RedirectToTab($id);
}

// verify that the job is unstarted
$jobid = (int)$params['jobid'];
$query = 'SELECT * FROM '.NMS_JOBS_TABLE.' WHERE jobid = ?';
$job = $db->GetRow($query,array($jobid));
if( !is_array($job) ) {
  $this->SetError($this->Lang('error_itemnotfound'));
  $this->RedirectToTab($id);
}
if( $job['status'] != NMS_JOBSTATUS_UNSTARTED ) {
  $this->SetError($this->Lang('error_badjobstatus'));
  $this->RedirectToTab($id);
}

// verify that this job is NOT in the mails table
$query = 'SELECT jobid FROM '.NMS_MAILS_TABLE.' WHERE jobid = ?';
$tmp = $db->GetOne($query,array($jobid));
if( $tmp ) {
  // it is in the mails table already.
  $this->SetError($this->Lang('error_dberror'));
  $this->RedirectToTab($id);
}

// add the cgjobmgr job
$jobmgr = cms_utils::get_module('CGJobMgr');
$thejob = new cgjobmgr_job($this->GetName().' - '.$job['title']);
$thejob->set_persistent_value('nms_jobid',$jobid);

$task = new cgjobmgr_simpletask('setup');
$task->set_persistent_data('nms_jobid',$jobid);
$task->set_function(array('nms_process_job','setup_mails'));
$thejob->add_task($task);

$messagesperhour = $this->GetPreference('messagesperhour',0);
if( $messagesperhour > 0 ) {
  $task = new cgjobmgr_simpletask('process emails simply');
  $thejob->set_iterate_flag(FALSE);
}
else {
  $task = new cgjobmgr_iterativetask('process emails iteratively');
}
$task->set_persistent_data('nms_jobid',$jobid);
$task->set_function(array('nms_process_job','send_emails'));
$thejob->add_task($task);


$task = new cgjobmgr_simpletask('finish');
$task->set_persistent_data('nms_jobid',$jobid);
$task->set_function(array('nms_process_job','finish'));
$thejob->add_task($task);

$thejob->save();
$rmtjobid = $thejob->id;

$tmp = array();
if( $job['extra'] != '' ) 
  $tmp = unserialize($job['extra']);
$tmp['cgjobmgr_jobid'] = $rmtjobid;
$job['extra'] = serialize($tmp);

$query = 'UPDATE '.NMS_JOBS_TABLE.' SET status = ?, extra = ? WHERE jobid = ?';
$dbr = $db->Execute($query,array(NMS_JOBSTATUS_STARTING,serialize($tmp),$jobid));
if( !$dbr ) {
  die($db->sql);
}

$this->SetMessage($this->Lang('msg_jobstarting'));
$this->RedirectToTab($id);
#
# EOF
#
?>